; Contains Licensed Material Copyright (C) 1987 Ansa Software -- MJP

; This procedure sets variables to be used in conjunction with the Data Entry
; Toolkit.  The reason why these variables are useful is that the DoWait
; procedure allows us to look at the last key that was pressed.  If we wanted
; to determine whether the last key pressed was [F1] (help), then rather than
; looking up the extended ASCII code for the F1 key, we could simply test to
; see if the character is TKHelp.
;
; Although the variables defined require a fair amount of memory (about 4K), we
; suggest that they be used in all cases where memory is not a critical
; constraint, as use of these variables will add to the readability of your
; code.  If you do run into memory problems, you can use the PrepareFinal
; subsystem of the toolkit to replace these variables (in you programs) with
; their actual values.  You may then simply remove the "SetKeycodes()" statement
; from your initialization procedure.
;
; Your programs need to call the SetKeycodes procedure if and only if they
; incorporate the variables listed below.  (The Toolkit will not automatically
; call the SetKeycodes procedure, as it does not use these variables).
;
Proc SetKeycodes()
   TKCtrlPgUp=-132       TKFieldView=-108      TKUp=-72          TKHelp=-59
   TKCtrlHome=-119       TKInstantPlay=-107    TKHome=-71        TKDitto=4
   TKCtrlPgDn=-118       TKInstantRecord=-106  TKMenu=-68        TKBeep=7
   TKCtrlEnd=-117        TKLockKey=-38         TKEditKey=-67     TKTab=9
   TKCtrlRight=-116      TKKeyLookup=-37       TKClearImage=-66  TKEnter=13
   TKCtrlLeft=-115       TKPgDn=-81            TKFormKey=-65     TKCancel=0
   TKPalMenu=-113        TKDown=-80            TKCheck=-64       TKRotate=18
   TKCoEditKey=-112      TKEnd=-79             TKExample=-63     TKUndo=21
   TKClearAll=-111       TKRight=-77           TKDownImage=-62   TKEsc=27
   TKInstantReport=-110  TKLeft=-75            TKUpImage=-61     TKDel=-83
   TKCheckPlus=-109      TKPgUp=-73            TKDo_It!=-60      TKIns=-82
   TKCtrlBreak=0         TKZoom=26             TKGoKey=7         TKRefresh=-19
   TKF40=-113   TKF30=-103   TKF20=-93   TKF10=-68   TKReverseTab=-15
   TKF39=-112   TKF29=-102   TKF19=-92   TKF9=-67    TKDeleteLine=25
   TKF38=-111   TKF28=-101   TKF18=-91   TKF8=-66    TKZoomNext=-44
   TKF37=-110   TKF27=-100   TKF17=-90   TKF7=-65    TKVertRuler=22
   TKF36=-109   TKF26=-99    TKF16=-89   TKF6=-64    TKBackspace=8
   TKF35=-108   TKF25=-98    TKF15=-88   TKF5=-63    TKCtrlBackspace=127
   TKF34=-107   TKF24=-97    TKF14=-87   TKF4=-62
   TKF33=-106   TKF23=-96    TKF13=-86   TKF3=-61
   TKF32=-105   TKF22=-95    TKF12=-85   TKF2=-60
   TKF31=-104   TKF21=-94    TKF11=-84   TKF1=-59
Endproc
