; Contains Licensed Material Copyright (C) 1987 Ansa Software -- MJP

; This procedure mimics a WAIT command in lookup help.  Unfortunately, although
; you can enter into lookup help from within a WAIT, you cannot enter into a
; WAIT from within lookup help.  Thus if the programmer wishes to provide the
; user access to the lookup help table, and a WAIT is not currently in effect,
; he/she must call this procedure.  THIS PROCEDURE WILL FUNCTION ONLY ON LOOKUP
; HELP TABLES.
;
; Please note that the procedure turns echo to normal in order to display the
; lookup table, and turns echo off upon exit.  This is different from the WAIT
; command which leaves the echo status unchanged.
;
; The procedure will return the ASCII value of the key that was pressed which
; caused the wait to be left (either Esc or Do_It!).  As with the WAIT comand,
; control will be passed back to the caller BEFORE the key is acted upon.
;
Proc LookupSelect()
   Echo   Normal             ;Display the table to the user
   While True
      Retval=getchar()
      If menuchoice()="Error" and     ;We could be in HELP, HELP INDEX, or ZOOM
           (Retval=-60 or Retval=27 or Retval=0)
         Then Quitloop
         Else Keypress Retval
      Endif
   Endwhile
   Echo Off
   Synccursor
   If Retval=0               ;CtrlBreak functions the same as Esc. Thus return
      Then Retval=27         ; the code for Esc unless Do_It! is pressed
   Endif
   Return Retval
Endproc
