; SCRIPT:     TICKER.SC
; Version:    2.0
; Date:       2 May 87
;
;
; TICKER contains the procedures that create a "tickertape" display of
; the stocks in the PRICE table.

PROC AddChar(s)            ; Add the next characters and display ticker
  PRIVATE l,i
  l = LEN(s)               ; Need to know how many character are added to string
  FOR i FROM 1 TO l        ; so that we loop right number of times...
    Toprint = SUBSTR(Toprint,2, 80) + SUBSTR(s,i,1)   ; add char to ticker line
    @12,0 ?? Toprint       ; Ticker string goes on line 12
    SLEEP Delay            ; Short pause, otherwise ticker moves too fast
  ENDFOR
ENDPROC

PROC TickerTape()
  PRIVATE Toprint,x,Delay,BetweenRefresh
  Toprint = SPACES(80)
  Delay = 100
  BetweenRefresh = 5
  VIEW "price"             ; We get ticker info from the PRICE table
  WHILE (TRUE)             ; Loop until user presses character
    SCAN                   ; Use SCAN to move through stocks in table
      IF (CHARWAITING())      ; Did user press a key?
        THEN  x = GETCHAR()   ; Yes, so let's see what they typed
          SWITCH
            CASE x = 45:          ; a minus was typed
              Delay = Delay + 50  ; meaning they want the ticker slower
            CASE x = 43:          ; a plus was typed
              Delay = MAX(Delay-50,0)  ; so make the ticker faster
            OTHERWISE:        ; user wants to leave
              CLEARALL RETURN ;   Clear up the workspace and go back to Main menu
          ENDSWITCH
      ENDIF                   ; No, so continue SCAN
      IF (MOD(RECNO(),BetweenRefresh) = 1)
        THEN REFRESH          ; Refresh every BetweenRefresh records
      ENDIF
      AddChar([Ticker] + " " + strval([Price]) +  "   ") ; Add stock name and price to ticker
    ENDSCAN
  ENDWHILE
ENDPROC

; DoTicker is the controlling procedure and performs a few housekeeping
; chores before calling the routine to display stock information.

PROC DoTicker()
  CLEAR                     ; PAL canvas needs to be cleared for ticker
  CURSOR OFF                ; Cursor not needed in this subsystem, so turn it off
  STYLE REVERSE             ; Put a reverse video border around line that
  @11,0 ?? SPACES(80)       ;    ticker will be on
  @13,0 ?? SPACES(80)
  STYLE                     ; Get back to normal STYLE for ticker display
  TickerTape()              ; and start the tape...
  CLEAR                     ; Get ticker off display before going back to Main menu
ENDPROC
